//+------------------------------------------------------------------+
//|                                                    dmx meter.mq4 |
//|                                                           mladen |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_chart_window
#property indicator_buffers 1

//
//
//
//
//

extern string DmxTimeFrames        = "M1;M5;M15;M30;H1;H4;D1;W1;MN";
extern int    DmxLength            =  32;
extern double DmxSpeed             = 2.5;
extern bool   DmxAdaptive          = true;
extern int    DmxResultSmooth      =   5;
extern double DmxResultSpeed       = 3.0;
extern bool   DmxResultAdaptive    = false;
extern int    IndicatorMagicNumber =   1;
extern int    IndicatorWindow      =   0;
extern int    IndicatorCorner      =   3;
extern int    IndicatorXPosition   =  10;
extern int    IndicatorYPosition   =  10;
extern int    IndicatorSteps       =  15;
extern bool   IndicatorMiddleLine  = true;
extern color  IndicatorTextColor   = LightGray;
extern color  IndicatorBackColor   = DimGray;
extern color  IndicatorStartColor  = OrangeRed;
extern color  IndicatorEndColor    = LimeGreen;

//
//
//
//
//

double dmx[];

//
//
//
//
//

string  identifierName;
string  indicatorFileName;
string  labels[];
int     periods[];
int     middle;
bool    calculating = false;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   SetIndexStyle(0,DRAW_NONE);
      if (DmxTimeFrames == "calculate")
      {
         SetIndexBuffer(0,dmx); calculating = true; return(0);
      }      
   
   //
   //
   //
   //
   //
   
   IndicatorCorner = MathMax(MathMin(IndicatorCorner, 3), 0);
   IndicatorSteps  = MathMax(MathMin(IndicatorSteps ,75),15);
   if (IndicatorMiddleLine)
      if (MathMod(IndicatorSteps,2)==0) IndicatorSteps++;
                               middle = IndicatorSteps/2;

   //
   //
   //
   //
   //
      
   DmxTimeFrames = StringTrimLeft(StringTrimRight(StringUpperCase(DmxTimeFrames)));
   if (StringSubstr(DmxTimeFrames,StringLen(DmxTimeFrames),1) != ";")
                    DmxTimeFrames = StringConcatenate(DmxTimeFrames,";");

   //
   //
   //
   //
   //                                   
            
   int s = 0;
   int i = StringFind(DmxTimeFrames,";",s);
   while (i > 0)
   {
      string current = StringSubstr(DmxTimeFrames,s,i-s);
      int    time    = stringToTimeFrame(current);
         if (time > 0) {
            ArrayResize(labels ,ArraySize(labels)+1);
            ArrayResize(periods,ArraySize(periods)+1);
                        labels[ArraySize(labels)-1] = timeFrameToString(time); 
                        periods[ArraySize(periods)-1] = time; }
                        s = i + 1;
                            i = StringFind(DmxTimeFrames,";",s);
   }
   indicatorFileName = WindowExpertName();
   identifierName    = "dmxmeter"+IndicatorMagicNumber+":";
}

//
//
//
//
//

int deinit()
{
   int identifierLength = StringLen(identifierName);

      for (int i=ObjectsTotal()-1; i>=0; i--)
      {
         string name = ObjectName(i);
         if (StringSubstr(name,0,identifierLength) == identifierName)
               ObjectDelete(name);
      }

   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

#define distance 43

int start()
{
   if (calculating) { calculateDmx(); return(0); }

   //
   //
   //
   //
   //
   
   int totalTimeFrames=ArraySize(periods);
   
   //
   //
   //
   //
   //
   
   int xPosition = IndicatorXPosition+10;
   int angle     = 90;
   int displ     = 1;
         
         if (IndicatorCorner==0 || IndicatorCorner==3) angle = 270;
         if (IndicatorCorner==0 || IndicatorCorner==2) displ =   0;
               setElement("0+0",xPosition      ,IndicatorYPosition,IndicatorBackColor,"gggggggg","Webdings",10,angle);
               setElement("0+1",xPosition+displ,IndicatorYPosition,IndicatorTextColor,"   Dmx "+DmxLength+"  ","Arial"   , 9,angle);
               xPosition++;
   
   //
   //
   //
   //
   //

   for (int t=0; t<totalTimeFrames; t++)
   {
      string label = labels[t];
      int    time  = periods[t];

      if (IndicatorCorner==1 || IndicatorCorner==3)
      {
         label = labels[totalTimeFrames-t-1];
         time  = periods[totalTimeFrames-t-1];
      }
         
      //
      //
      //
      //
      //
       
      double dmx = iCustom(NULL,time,indicatorFileName,"calculate",DmxLength,DmxSpeed,DmxAdaptive,DmxResultSmooth,DmxResultSpeed,DmxResultAdaptive,0,0)+100;
      for (int i=0; i<IndicatorSteps; i++)
      {
         int    pos = i; if (IndicatorCorner==0 || IndicatorCorner==1) pos = IndicatorSteps-i-1;
         double value = (i+1)*200.0/(IndicatorSteps+1);
            
         //
         //
         //
         //
         //

         if (IndicatorMiddleLine)
         {
            if (i==middle)
            {
                setElement(t+"-"+i,xPosition+t*distance,IndicatorYPosition+pos*7,gradientColor(i,IndicatorSteps,IndicatorStartColor,IndicatorEndColor));
                continue; 
            }                
            if (dmx>100)
            {
               if (i<middle) { setElement(t+"-"+i,xPosition+t*distance,IndicatorYPosition+pos*7,IndicatorBackColor); continue; }
               if (dmx>=value)
                     setElement(t+"-"+i,xPosition+t*distance,IndicatorYPosition+pos*7,gradientColor(i,IndicatorSteps,IndicatorStartColor,IndicatorEndColor));
               else  setElement(t+"-"+i,xPosition+t*distance,IndicatorYPosition+pos*7,IndicatorBackColor);       
            }
            else
            {
               if (i>middle) { setElement(t+"-"+i,xPosition+t*distance,IndicatorYPosition+pos*7,IndicatorBackColor); continue; }
               if (dmx<=value)
                     setElement(t+"-"+i,xPosition+t*distance,IndicatorYPosition+pos*7,gradientColor(i,IndicatorSteps,IndicatorStartColor,IndicatorEndColor));
               else  setElement(t+"-"+i,xPosition+t*distance,IndicatorYPosition+pos*7,IndicatorBackColor);       
            }
            continue;
         }
         
         //
         //
         //
         //
         //
         
         if (dmx>=value)
               setElement(t+"-"+i,xPosition+t*distance,IndicatorYPosition+pos*7,gradientColor(i,IndicatorSteps,IndicatorStartColor,IndicatorEndColor));
         else  setElement(t+"-"+i,xPosition+t*distance,IndicatorYPosition+pos*7,IndicatorBackColor);       
      }

      //
      //
      //
      //
      //
      
      setElement(t+"-"+i,xPosition+t*distance+10,IndicatorYPosition+i*7,IndicatorTextColor,label,"arial",10);
   }
   return(0);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double stored[][28];

//
//
//
//
//

void calculateDmx()
{
   int counted_bars=IndicatorCounted();
   int i,r,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=Bars-counted_bars;
           if (ArrayRange(stored,0) != Bars) ArrayResize(stored,Bars);

   //
   //
   //
   //
   //
   
   for(i=limit, r=Bars-limit-1; i>=0; i--,r++)
   {
      double currTR  = iAverage(MathMax(High[i],Close[i+1])-MathMin(Low[i],Close[i+1]),DmxLength,DmxSpeed,DmxAdaptive,r,0);
      double DeltaHi = High[i] - High[i+1];
      double DeltaLo = Low[i+1] - Low[i];
      double plusDM  = 0.00;
      double minusDM = 0.00;

         if ((DeltaHi > DeltaLo) && (DeltaHi > 0)) plusDM  = DeltaHi;
         if ((DeltaLo > DeltaHi) && (DeltaLo > 0)) minusDM = DeltaLo;      
         
      //
      //
      //
      //
      //

      double DIp = 0.00;
      double DIm = 0.00;

      if (currTR > 0.00)
      {
         DIp = 100.0*iAverage(plusDM ,DmxLength,DmxSpeed,false,r, 7)/currTR;
         DIm = 100.0*iAverage(minusDM,DmxLength,DmxSpeed,false,r,14)/currTR;
      }
      if ((DIp+DIm) != 0)
            dmx[i] = 100.00*iAverage((DIp-DIm)/(DIp+DIm),DmxResultSmooth,DmxResultSpeed,DmxResultAdaptive,r,21);
      else  dmx[i] = 100.00*iAverage(0                  ,DmxResultSmooth,DmxResultSpeed,DmxResultAdaptive,r,21);
   }   
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

#define E1  0
#define E2  1
#define E3  2
#define E4  3
#define E5  4
#define E6  5
#define res 6

//
//
//
//
//

double iAverage(double price, double averagePeriod, double const, bool adaptive, int r, int ashift=0)
{
   double e1=stored[r-1][E1+ashift];  double e2=stored[r-1][E2+ashift];
   double e3=stored[r-1][E3+ashift];  double e4=stored[r-1][E4+ashift];
   double e5=stored[r-1][E5+ashift];  double e6=stored[r-1][E6+ashift];

   //
   //
   //
   //
   //

      if (adaptive && (averagePeriod > 1))
      {
         double minPeriod = averagePeriod/2.0;
         double maxPeriod = minPeriod*5.0;
         int    endPeriod = MathCeil(maxPeriod);
         double signal    = MathAbs((price-stored[r-endPeriod][res+ashift]));
         double noise     = 0.00000000001;

            for(int k=1; k<endPeriod; k++) noise=noise+MathAbs(price-stored[r-k][res+ashift]);

         averagePeriod = ((signal/noise)*(maxPeriod-minPeriod))+minPeriod;
      }
      
      //
      //
      //
      //
      //
      
      double alpha = (2.0+const)/(1.0+const+averagePeriod);

      e1 = e1 + alpha*(price-e1); e2 = e2 + alpha*(e1-e2); double v1 = 1.5 * e1 - 0.5 * e2;
      e3 = e3 + alpha*(v1   -e3); e4 = e4 + alpha*(e3-e4); double v2 = 1.5 * e3 - 0.5 * e4;
      e5 = e5 + alpha*(v2   -e5); e6 = e6 + alpha*(e5-e6); double v3 = 1.5 * e5 - 0.5 * e6;

   //
   //
   //
   //
   //

   stored[r][E1+ashift]  = e1;  stored[r][E2+ashift] = e2;
   stored[r][E3+ashift]  = e3;  stored[r][E4+ashift] = e4;
   stored[r][E5+ashift]  = e5;  stored[r][E6+ashift] = e6;
   stored[r][res+ashift] = price;
   return(v3);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void setElement(string element, int x, int y, color ecolor=Silver, string text = "ggggggg", string fontname="Webdings", int fontsize = 5.5, int angle=0)
{
   string name = identifierName+element;
   ObjectCreate(name, OBJ_LABEL, IndicatorWindow, 0, 0);
      ObjectSet(name, OBJPROP_XDISTANCE, x);
      ObjectSet(name, OBJPROP_YDISTANCE, y);
      ObjectSet(name, OBJPROP_BACK, FALSE);
      ObjectSet(name, OBJPROP_CORNER, IndicatorCorner);
      ObjectSet(name, OBJPROP_ANGLE, angle);
      ObjectSetText(name, text, fontsize, fontname, ecolor);
}

//
//
//
//
//

color gradientColor(int step, int totalSteps, color from, color to)
{
   color newBlue  = getColor(step,totalSteps,(from & 0XFF0000)>>16,(to & 0XFF0000)>>16)<<16;
   color newGreen = getColor(step,totalSteps,(from & 0X00FF00)>> 8,(to & 0X00FF00)>> 8) <<8;
   color newRed   = getColor(step,totalSteps,(from & 0X0000FF)    ,(to & 0X0000FF)    )    ;
   return(newBlue+newGreen+newRed);
}
color getColor(int stepNo, int totalSteps, color from, color to)
{
   double step = (from-to)/(totalSteps-1.0);
   return(MathRound(from-step*stepNo));
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(iTfTable[i]);
                                                      return(0);
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string StringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}